#ifndef FFMPEGVIDEO_H
#define FFMPEGVIDEO_H

#define inline _inline
#define __STDC_CONSTANT_MACROS
#include <stdafx.h>
#include <string>
#include <windows.h>
//#include <Image.h>
#include <utilitaires/alx_liste.h>

#include <utils.h>

#include <iostream>
using namespace std;

extern "C" {
  #include <libavcodec\avcodec.h>
  #include <libavformat/avformat.h>
  #include "libavformat/avio.h"
  #include <libswscale/swscale.h>
}

#include <Infos_audio.h>


class FFMpegVideo {
private:
	unsigned int video_pts;
	struct SwsContext *img_convert_ctx;
	std::string error_msg;

public :
	FFMpegVideo();
	FFMpegVideo(const char *fname);
	FFMpegVideo(const std::string & fname);
	~FFMpegVideo();

public:
	int startAcquisition();
	void stopAcquisition();

	const char* get_error_message() const {return error_msg.c_str();}

	bool getImage(/*util::ByteImage & img*/void *img);
	bool getImageNr(unsigned long frame, void *img/*util::ByteImage & img*/);
	bool seek(unsigned long frame, bool iframe = false, SeekMode sm = ABS);

	const int   numFrames()      {return nrFrames;  }

	const unsigned int Nb_total_video_frames() const {return nb_total_video_frames;}

	const double getFramerate( ) {return mFramerate;}
	const double setFramerate(const double v) {return mFramerate = v;}

	inline const unsigned int Video_pts() const {return video_pts;}
	inline void Video_pts(const unsigned int v) {this->video_pts = v;}

	inline const unsigned int Video_pts_for_audio      () {return info_for_sound_CB.video_pts;}
	inline void Video_pts_for_audio(const unsigned int v) {info_for_sound_CB.video_pts = v;}

	inline const int Width () const {return width;}
	inline const int Height() const {return height;}

	inline const bool Debug_mode() const {return debug_mode;}
	inline void Debug_mode(const bool b) {debug_mode = b;}

	inline void IFS_Drain_all() {Info_for_sound_Drain_all(&info_for_sound_CB);}

	void Lock();
	void UnLock();

	const double get_Synchronisation_threshold() const;
	void set_Synchronisation_threshold(const double v);

	inline const unsigned int Nb_channels() const {return nb_channels;}
	inline Info_for_sound_CB* get_Info_for_sound_CB() {return &info_for_sound_CB;}
	inline const unsigned int Sound_sample_rate() const {return sound_sample_rate;}
	inline const unsigned int Audio_buffer_size() const {return size_audio_buf;}
	inline void Audio_buffer_size(const unsigned int v) {size_audio_buf = v;
														 if(audio_buf == (uint8_t*)NULL) {free(audio_buf);}
														 audio_buf = (uint8_t*)av_malloc(v);
														}

public:
	const bool open(const char *fname);
	const bool open(const std::string & fname);
	void close();
		
public:
	std::string information() const;

private:
	bool getNextFrame();

	private:
		AVFormatContext *formatCtx;
		AVCodecContext *codecCtx, *audio_codecCtx;
		int videoStream;
		int audioStream;
		std::string id;
		int nrFrames;
		bool started;
		int curFrame;
		int width, height;
		double mFramerate;
		unsigned int nb_total_video_frames;

		AVFrame *frame;
		bool debug_mode;

	   // Audio
		Mutex mutex_audio;
		Info_for_sound_CB info_for_sound_CB;
		Info_buffer_audio info_buffer_audio_tmp;
        alx_liste<AVPacket>          L_audio_pkt;
		
		unsigned int size_audio_buf, sound_sample_rate, nb_channels;
		uint8_t *audio_buf;
		int audio_decode_frame(AVCodecContext *aCodecCtx, uint8_t *audio_buf, int buf_size, AVPacket *pkt);
		int get_audio_packet(AVPacket *pkt);
		int put_audio_packet(AVPacket *pkt);
		void Process_audio_packets();
		//PacketQueue audioq;


};

#endif