#ifndef __FFMPEG_TCL_UTILS__
#define __FFMPEG_TCL_UTILS__

#include <windows.h>

// Video management
typedef enum
{
	ABS,
	FORWARD,
	BACKWARD,
	END
} SeekMode; 

// Mutex
class Mutex
{
    private:
        #if defined (unix) || defined (__APPLE__)
		pthread_mutex_t m;
		#endif

		#if defined (WIN32) || defined (_WIN32_WCE)
		HANDLE hMutex;
		#endif

    public:
        Mutex(void);
        ~Mutex(void);

		/**
		 * Lock the mutex. If the mutex is already lock, it make the calling thread waiting until a lock's owner unlock the mutex
		 * @see unlock()
		 */
        void lock(void);

         /**
		 * Unlock the mutex
		 * @see lock()
		 */
        void unlock(void);
};


#endif